#Author: Peter Csiba
#Email: petherz@gmail.com 
#Company: Black Swan Rational 

#TODO check if unicode is ok 
#TODO remove too frequent words 
#TODO nltk POS_TAGS and bullshits 
#TODO singulars #only_singulars = [w for w in noun_list if w == en.noun.singular(w)]
#TODO in 'db-new' including last row makes error 
#TODO isolate generating dictionary 
#TODO use docs_used for release (calculation is spared) 
#from stemming.porter2 import stem #stem("simpsons")
#import en

import logging

import cPickle
import gensim

import csv
import sys 
import time 
#from sklearn.neighbors import BallTree

#======== GENERAL SETTINGS ========
IS_SHOW_TOPICS = True

# True -> new lsi will trained&saved based on corpus, dictionary, word_frequencies, ... 
# False -> lsi will be loaded from file (you must run with true before) 
IS_TRAIN_LSI = True 

#======== LSI / LDA settings ======
NUM_TOPICS = int(sys.argv[2])
NUM_WORDS_SHOW = 50

#========== LOGGING ===============
db_name = sys.argv[1] 

logging.basicConfig(format='%(asctime)s : %(levelname)s : %(message)s', level=logging.INFO)
logger = logging.getLogger('gen_topic')

run_id = db_name + "_" + str(int(time.time()))
ftopics = csv.writer(open("log/topics_" + run_id + ".csv", "w"))

#=================== DICTIONARY ==============
logger.info("ME: Loading dictionary") 
dictionary = cPickle.load(open("dictionary/" + db_name + ".pkl", "r")) 
logger.info("ME: Dictionary("+str(len(dictionary))+")") 

#================== READING CORPUS SEQUENTIALLY ============

#TODO seriously, it takes 8s for 10,000 rows? 
class CorpusMemoryFriendly(object):
  def __iter__(self):    
    logger.info("ME: Loading corpus doc to use") 
    
    fh_corpus_docs_used = open("model/docs_used_" + db_name + ".csv", "r")
    corpus_docs_used = csv.reader(fh_corpus_docs_used)
    
    c = 0 
    for line in corpus_docs_used:
      #omit id 
      yield dictionary.doc2bow(line[1:])
      
      c += 1
      if c % 10000 == 0:
        logger.info("ME:   " + str(c)) 
      
    fh_corpus_docs_used.close() 

corpus_memory_friendly = CorpusMemoryFriendly() 

#===========================================================
#================== TRAINING LSI   =========================
#===========================================================
if IS_TRAIN_LSI: 
  logger.info("ME: Transforming corpus") 
  tfidf = gensim.models.TfidfModel(corpus_memory_friendly)
  print "tfidf: ", tfidf

  #TODO consider using LDA:  extract 100 LDA topics, using 1 pass and updating once every 1 chunk (10,000 documents)
  #>>> lda = gensim.models.ldamodel.LdaModel(corpus=mm, id2word=id2word, num_topics=100, update_every=1, chunksize=10000, passes=1)

  logger.info("ME: Running LSI") 
  lsi = gensim.models.lsimodel.LsiModel(corpus=tfidf[corpus_memory_friendly], id2word=dictionary, num_topics=NUM_TOPICS)

  # print the most contributing words (both positively and negatively) for each of the first ten topics
  #lsi.print_topics(10)

  logger.info("ME: Dumping LSI") 
  cPickle.dump(lsi, open("model/lsi_" + db_name + ".pkl", "w"))
else: #not IS_TRAIN_LSI 
  logger.info("ME: Loading LSI directly") 
  lsi = cPickle.load(open("model/lsi_" + db_name + ".pkl", "r"))
  logger.info("ME:   Done") 

#===================== SHOW TOPICS ================
if IS_SHOW_TOPICS: 
  logger.info("ME: Output show topics to csv") 
  topics_arr = lsi.show_topics(NUM_TOPICS, NUM_WORDS_SHOW)
  for topic_str in topics_arr: 
    ftopics.writerow(topic_str.replace('"', '').split(" + "))
    
  logger.info("ME: Output show topics to pickle") 
  cPickle.dump(topics_arr, open("model/topics_" + db_name + ".pkl", "w"))

