#include <iostream> 
#include <vector> 
#include <map> 
#include <algorithm> 
#include <string> 
#include <fstream> 
#include <cstdio> 
#include <cstdlib> 
#include <sstream> 
#include <cmath> 
#include <ctime> 
#include <utility> 
#include <queue> 
#include <set> 

using namespace std; 


#define REP(i, to) for(int i=0; i<to; i++)
#define FOREACH(KEY, VALUE, ITER, M) for(map<KEY,VALUE>::iterator ITER = M.begin() ; ITER != M.end() ; ++ITER)

#define CLUSTER_COUNT 100
int TOPIC_COUNT = 100;
#define COUNT_CLUSTER_DISTANCE_SAMPLES 1000000 

#define LSH_BITS 16

typedef pair<int, int> PII; 
typedef pair<double, PII> PD_II; 

double length(vector<double>& a){
  double result = 0.0;
  REP(i, a.size()) result += a[i] * a[i]; 
  return sqrt(result); 
}

double scalar(vector<double>& a, vector<double>& b){
  double result = 0.0;
  REP(i, a.size()) result += a[i] * b[i]; 
  return result; 
}

//The resulting similarity ranges from −1 meaning exactly opposite, to 1 meaning exactly the same, with 0 usually indicating independence, and in-between values indicating intermediate similarity or dissimilarity.
double cos_sim(vector<double>& a, vector<double>& b){
  return scalar(a,b) / (length(a) * length(b)); 
}

int max_index(vector<double>& a){
  int result = 0;
  REP(i, a.size()) if(a[result] < a[i]) result = i;
  return result; 
}

double avg_value(vector<double>& a){
  double result = 0.0; 
  REP(i, a.size()) result += a[i] / ((double)a.size()); 
  return result; 
}

double rand_double(double from, double to){
  return from + (((double) (rand() % 1000000)) / ((1000000.0) / (to -from))); 
}

string i2str(int a){
  stringstream ss;
  ss << a;
  return ss.str();
}

int str2i(string& str){
  istringstream buffer(str);
  int value;
  buffer >> value; 
  return value; 
}

//http://stackoverflow.com/questions/12966957/is-there-an-equivalent-in-c-of-phps-explode-function
std::vector<std::string> explode(std::string const & s, char delim)
{
    std::vector<std::string> result;
    std::istringstream iss(s);

    for (std::string token; std::getline(iss, token, delim); )
    {
        result.push_back(token);
    }

    return result;
}

vector<int> read_csv_int_line(const string& line){
  vector<string> tokens = explode(line, ','); 
  
  vector<int> result; 
  REP(i, tokens.size()) result.push_back(str2i(tokens[i]));
  return result; 
}
