import logging
import cPickle
import csv
import sys 
import time

#========== LOGGING ============

logging.basicConfig(format='%(asctime)s : %(levelname)s : %(message)s', level=logging.INFO)
logger = logging.getLogger('nearest') 

corpus_name = sys.argv[1] 
topic_model_name = sys.argv[2] 
NUM_TOPICS = int(sys.argv[3])  #TODO there must be a way to calculate it from LSI model 

run_id = corpus_name + "_" + str(int(time.time()))

#=================== DICTIONARY ==============
logger.info("ME: Loading dictionary") 
dictionary = cPickle.load(open("dictionary/" + topic_model_name + ".pkl", "r")) 
logger.info("ME: Dictionary("+str(len(dictionary))+")") 

#=========== LOAD LSI ===========
logger.info("ME: Loading LSI directly") 
lsi = cPickle.load(open("model/lsi_" + topic_model_name + ".pkl", "r"))
logger.info("ME:   Done") 

#==================== LOAD CORPUS DATA -> LSI VECTOR======================
logger.info("ME: Loading documents")
corpus_csv = csv.reader(open("model/docs_used_" + corpus_name + ".csv", "r")) 
vectors_file = open("model/vectors_" + corpus_name + ".dat", "w") 

corpus_data = {} 
cc = 0 
for line in corpus_csv: 
  #convert sparse representation to normal vector 
  row = [0.0] * NUM_TOPICS 
  for sparse_el in lsi[dictionary.doc2bow(line[1:])]: 
    row[sparse_el[0]] = sparse_el[1]
  
  corpus_data[line[0]] = row 
  
  cc += 1
  if cc % 40000 == 0:
    print logger.info("ME:   " + str(cc))
  
vectors_file.write(str(len(corpus_data))) 
vectors_file.write(" ") 
vectors_file.write(str(NUM_TOPICS))
vectors_file.write("\n") 

logger.info("ME: Transforming documents")
cc = 0 
for k, vector in corpus_data.iteritems(): 
  vectors_file.write(str(k))
  #vectors_file.write(len(int(vector))) # already written in header 
  for v in vector:
    vectors_file.write(" ")
    vectors_file.write(str(v))
   
  vectors_file.write("\n") 
  
  cc += 1
  if cc % 40000 == 0:
    print logger.info("ME:   " + str(cc))
    
vectors_file.close() 
  